/**
 * {Point}
 * @author yutent<yutent.io@gmail.com>
 * @date 2024/02/04 11:53:48
 */

export class Point {
  constructor(x, y) {
    this.x = x
    this.y = y
  }

  add(point) {
    return new Point(this.x + point.x, this.y + point.y)
  }

  sub(point) {
    return new Point(this.x - point.x, this.y - point.y)
  }

  mul(value) {
    return new Point(this.x * value, this.y * value)
  }

  div(value) {
    return new Point(this.x / value, this.y / value)
  }

  dist() {
    return Math.sqrt(this.x * this.x + this.y * this.y)
  }

  sqr() {
    return this.x * this.x + this.y * this.y
  }
}

/*
 * Check if 3 points are in line, and second in the midle.
 * Used to replace quad curves with lines or join lines
 *
 */
export function isInLine(p1, m, p2, accuracy) {
  let a = p1.sub(m).sqr()
  let b = p2.sub(m).sqr()
  let c = p1.sub(p2).sqr()

  // control point not between anchors
  if (a > b + c || b > a + c) {
    return false
  }

  // count distance via scalar multiplication
  let distance = Math.sqrt(
    Math.pow((p1.x - m.x) * (p2.y - m.y) - (p2.x - m.x) * (p1.y - m.y), 2) / c
  )

  return distance < accuracy ? true : false
}
